<template>
  <v-container>
    <v-dialog v-model="dialog" persistent max-width="800">
      <v-card>
        <v-form ref="listForm" @submit.prevent="sendForm()">
          <v-toolbar v-if="!$store.getters['isMobile']" dark extended extension-height="4" color="blue">
            <span class="headline black--text">
              <v-icon color="black" size="30px" >folder_open</v-icon>
              &nbsp;&nbsp;
              <span v-if="obj && obj.id === -1">Add a list</span>
              <span v-else>Edit a list</span>
            </span>
            <v-spacer></v-spacer>
            <progress-bar
              :loading="sending"
              color="deep-purple accent-4"
              slot="extension"
            />
          </v-toolbar>
          <v-container fluid grid-list-md>
              <v-layout fluid wrap>
                <v-flex xs12>
                  <v-text-field :rules="rules.required" v-model="obj.title" label="List title*" required></v-text-field>
                </v-flex>
                <v-flex xs12>
                  <v-radio-group :rules="rules.required" v-model="obj.color" row required>
                    <v-radio label="Blue" color="blue" value="blue"></v-radio>
                    <v-radio label="Red" color="red" value="red"></v-radio>
                    <v-radio label="Green" color="green" value="green"></v-radio>
                    <v-radio label="Yellow" color="yellow" value="yellow"></v-radio>
                    <v-radio label="Purple" color="purple" value="purple"></v-radio>
                    <v-radio label="Orange" color="orange" value="orange"></v-radio>
                    <v-radio label="Grey" color="grey" value="grey"></v-radio>
                  </v-radio-group>
                </v-flex>
              </v-layout>
            <small>* Required field</small>
          </v-container>
          <v-card-actions>
            <v-btn color="red darken-1" flat @click="$emit('cancel')">Cancel</v-btn>
            <v-spacer></v-spacer>
            <v-btn type="submit" color="green darken-1" flat >
              <span v-if="obj && obj.id === -1">Add</span>
              <span v-else>Save</span>
            </v-btn>
          </v-card-actions>
        </v-form>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
import progressBar from '@/components/NavBar/ProgressBar'

import ListService from '@/services/ListService'

export default {
  components: {
    'progress-bar': progressBar
  },
  props: {
    dialog: {
      type: Boolean,
      required: true
    },
    list: {
      required: false,
      default: null
    }
  },
  data: () => ({
    listService: new ListService(),
    obj: {
      title: '',
      color: 'grey'
    },
    sending: false
  }),
  watch: {
    list: function (val) {
      this.$refs.listForm.resetValidation()
      if (val) {
        this.obj = this.list
      } else {
        this.obj = {
          title: '',
          color: 'grey'
        }
      }
    }
  },
  computed: {
    rules: function () {
      return {
        required: [
          val => (val || '').length > 0 || 'Required field'
        ]
      }
    }
  },
  methods: {
    sendForm: function () {
      if (this.$refs.listForm.validate()) {
        this.sending = true
        if (this.obj.id === -1) {
          this.listService.addList(this.obj).then((response) => {
            this.obj = { title: '', color: 'grey' }
            this.$emit('refreshList', response.data.id)
            this.sending = false
          }, (error) => {
            this.errorService.getServeurNotif(error.status, error.bodyText)
            this.$store.dispatch('alert/error', { content: 'Impossible to add the list. Try again later.' })
            this.sending = false
          })
        } else {
          this.listService.editList(this.obj).then((response) => {
            this.obj = { title: '', color: 'grey' }
            this.$emit('refreshList', response.data.id)
            this.sending = false
          }, (error) => {
            this.errorService.getServeurNotif(error.status, error.bodyText)
            this.$store.dispatch('alert/error', { content: 'Impossible to edit the list. Try again later.' })
            this.sending = false
          })
        }
      }
    },
    required: function (name) {
      return name + ' *'
    }
  }
}
</script>
